/*
** Modular Logfile Analyzer
** Copyright 2000 Jan Kneschke <jan@kneschke.de>
**
** Homepage: http://www.modlogan.org
**

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version, and provided that the above
    copyright and permission notice is included with all distributed
    copies of this or derived software.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

**
** $Id: mlocale.h,v 1.14 2003/01/06 10:56:13 ostborn Exp $
*/

#ifndef _M_LOCALE_H_
#define _M_LOCALE_H_

#include "config.h"
#include "mconfig.h"

#ifdef HAVE_GETTEXT
#include <libintl.h>
#include <locale.h>
#define _(String) gettext(String)
#else
#define _(String) String
#endif

int init_locale(mconfig *conf);
char *mhttpcodes(int status);
long long isondx(const char *str);
char *misoname(const char *str);

#define M_RESOLV_UNKNOWN_ERROR	-1
#define M_RESOLV_UNRESOLVED	-2


#endif
